version: '3.9'

services:

{% for host in ansible_play_batch %}
  minio{{ loop.index }}:
    image: quay.io/minio/minio
    hostname: minio{{ loop.index }}
    volumes:
      - {{minio_data_dir}}:/data
    networks:
      - host
    deploy:
      restart_policy:
        delay: 10s
        max_attempts: 10
        window: 60s
      placement:
        constraints:
          - node.labels.minio_{{ loop.index }}==true
    command: server --address ":{{ minio_api_port }}" --console-address ":{{ minio_ui_port }}" http://minio{1...{{ ansible_play_batch|length }}}/data
    secrets:
      - secret_key
      - access_key
    healthcheck:
      test: ["CMD", "curl", "-f", "http://localhost:{{ minio_ui_port }}/minio/health/live"]
      interval: 30s
      timeout: 20s
      retries: 3
    extra_hosts:
    {% for i in ansible_play_batch %}
      - "minio{{loop.index}}:{{ hostvars[i]['ansible_facts']['default_ipv4']['address'] }}"
    {% endfor %}

{% endfor %}

secrets:
  secret_key:
    external: true
  access_key:
    external: true

networks:
  host:
    external: true
